Index: src/plugin/src/xplra/Makefile.am
===================================================================
--- src/plugin/src/xplra/Makefile.am	(revision 38)
+++ src/plugin/src/xplra/Makefile.am	(revision 39)
@@ -17,4 +17,5 @@
 	GetMultiDataRefRequest.cc	\
 	SetMultiDataRefRequest.cc	\
+	ReloadPluginsRequest.cc		\
 	MessageWindow.cc		\
 	MessageRequest.cc
@@ -34,4 +35,5 @@
 	GetMultiDataRefRequest.h	\
 	SetMultiDataRefRequest.h	\
+	ReloadPluginsRequest.h		\
 	MessageWindow.h			\
 	MessageRequest.h
Index: src/plugin/src/xplra/Protocol.h
===================================================================
--- src/plugin/src/xplra/Protocol.h	(revision 38)
+++ src/plugin/src/xplra/Protocol.h	(revision 39)
@@ -97,4 +97,9 @@
 
     /**
+     * Command: reload the plugins
+     */
+    static const uint8_t COMMAND_RELOAD_PLUGINS = 0x32;
+
+    /**
      * Command: show a message in the message window.
      */
Index: src/plugin/src/xplra/ReloadPluginsRequest.cc
===================================================================
--- src/plugin/src/xplra/ReloadPluginsRequest.cc	(revision 39)
+++ src/plugin/src/xplra/ReloadPluginsRequest.cc	(revision 39)
@@ -0,0 +1,52 @@
+// Copyright (c) 2013 by István Váradi
+
+// This file is part of XPLRA, a remote-access plugin for X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+//------------------------------------------------------------------------------
+
+#include "ReloadPluginsRequest.h"
+
+#include <XPLMPlugin.h>
+
+//------------------------------------------------------------------------------
+
+using xplra::ReloadPluginsRequest;
+
+//------------------------------------------------------------------------------
+
+void ReloadPluginsRequest::execute()
+{
+    XPLMReloadPlugins();
+}
+
+//------------------------------------------------------------------------------
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/plugin/src/xplra/ReloadPluginsRequest.h
===================================================================
--- src/plugin/src/xplra/ReloadPluginsRequest.h	(revision 39)
+++ src/plugin/src/xplra/ReloadPluginsRequest.h	(revision 39)
@@ -0,0 +1,64 @@
+// Copyright (c) 2013 by István Váradi
+
+// This file is part of XPLRA, a remote-access plugin for X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLRA_RELOADPLUGINSREQUEST_H
+#define XPLRA_RELOADPLUGINSREQUEST_H
+//------------------------------------------------------------------------------
+
+#include "Request.h"
+
+//------------------------------------------------------------------------------
+
+namespace xplra {
+
+//------------------------------------------------------------------------------
+
+/**
+ * A request that simply reloads all plugins.
+ */
+class ReloadPluginsRequest : public Request
+{
+protected:
+    /**
+     * Execute the request.
+     */
+    virtual void execute();
+};
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplra */
+
+//------------------------------------------------------------------------------
+#endif // XPLRA_RELOADPLUGINSREQUEST_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/plugin/src/xplra/ServerThread.cc
===================================================================
--- src/plugin/src/xplra/ServerThread.cc	(revision 38)
+++ src/plugin/src/xplra/ServerThread.cc	(revision 39)
@@ -39,4 +39,5 @@
 #include "GetMultiDataRefRequest.h"
 #include "SetMultiDataRefRequest.h"
+#include "ReloadPluginsRequest.h"
 #include "MessageRequest.h"
 
@@ -153,4 +154,6 @@
         } else if (command==Protocol::COMMAND_GET_VERSIONS) {
             if (!handleGetVersions()) break;
+        } else if (command==Protocol::COMMAND_RELOAD_PLUGINS) {
+            if (!handleReloadPlugins()) break;
         } else if (command==Protocol::COMMAND_SHOW_MESSAGE) {
             if (!handleShowMessage()) break;
@@ -409,4 +412,16 @@
 //------------------------------------------------------------------------------
 
+bool ServerThread::handleReloadPlugins()
+{
+    ReloadPluginsRequest request;
+    if (!requestQueue.execute(&request)) return false;
+
+    stream.writeU8(Protocol::RESULT_OK);
+
+    return true;
+}
+
+//------------------------------------------------------------------------------
+
 bool ServerThread::handleShowMessage()
 {
Index: src/plugin/src/xplra/ServerThread.h
===================================================================
--- src/plugin/src/xplra/ServerThread.h	(revision 38)
+++ src/plugin/src/xplra/ServerThread.h	(revision 39)
@@ -243,4 +243,11 @@
 
     /**
+     * Handle the COMMAND_RELOAD_PLUGINS command.
+     *
+     * @return true, if we can continue, false if the thread should quit
+     */
+    bool handleReloadPlugins();
+
+    /**
      * Handle the COMMAND_SHOW_MESSAGE command
      *