Index: test/basicctest.c
===================================================================
--- test/basicctest.c	(revision 36)
+++ test/basicctest.c	(revision 40)
@@ -33,4 +33,25 @@
 #include <stdio.h>
 #include <string.h>
+
+#ifdef _WIN32
+#include <windows.h>
+#else
+#include <unistd.h>
+#endif
+
+//------------------------------------------------------------------------------
+
+#ifdef _WIN32
+void _sleep(int ms)
+{
+    Sleep(ms);
+}
+#else
+void _sleep(int ms)
+{
+    usleep(ms*1000);
+}
+#endif
+
 
 //------------------------------------------------------------------------------
@@ -74,4 +95,8 @@
     }
 
+    printf("Showing a message...\n");
+    if (xplra_show_message(connectionID, "[basictest] Starting tests", 5.0)<0) goto error;
+    printf("\n");
+
     printf("Querying the versions...\n");
     if (xplra_get_versions(connectionID, &xplaneVersion,
@@ -341,4 +366,26 @@
     printf("The tail number is: '%s'\n\n", (char*)tailNum);
 
+    printf("Preparing for the message tests, sleeping for 5 seconds...\n");
+    _sleep(5*1000);
+
+    printf("Showing a message for 10 seconds...\n");
+    if (xplra_show_message(connectionID, "[basictest] this message appears for 10 seconds", 10.0)<0) {
+        goto error;
+    }
+
+    printf("Sleeping for 3 seconds...\n");
+    _sleep(3*1000);
+
+    printf("Showing another message interrupting the previous one for 3 seconds");
+    if (xplra_show_message(connectionID, "[basictest] but this message interrupts it, and is displayed for 3 seconds", 3.0)<0) {
+        goto error;
+    }
+
+    printf("Sleeping for 5 seconds...\n");
+    _sleep(5*1000);
+    if (xplra_show_message(connectionID, "[basictest] and the tests come to an end!", 5.0)<0) {
+        goto error;
+    }
+
     goto cleanup;
 error:
Index: test/basictest.cc
===================================================================
--- test/basictest.cc	(revision 36)
+++ test/basictest.cc	(revision 40)
@@ -31,4 +31,6 @@
 #include <hu/varadiistvan/xplra/XPlane.h>
 
+#include <hu/varadiistvan/scpl/Thread.h>
+
 #include <cstdio>
 #include <cstring>
@@ -39,4 +41,6 @@
 using hu::varadiistvan::xplra::Exception;
 using hu::varadiistvan::xplra::ProtocolException;
+
+using hu::varadiistvan::scpl::Thread;
 
 using std::string;
@@ -56,4 +60,8 @@
         int xplmVersion = 0;
         int xplraVersion = 0;
+
+        printf("Showing a message...\n");
+        xplane.showMessage("[basictest] Starting tests", 5.0);
+        printf("\n");
 
         printf("Querying the versions...\n");
@@ -242,4 +250,19 @@
         }
 
+        printf("Preparing for the message tests, sleeping for 5 seconds...\n");
+        Thread::sleep(5*1000);
+
+        printf("Showing a message for 10 seconds...\n");
+        xplane.showMessage("[basictest] this message appears for 10 seconds", 10.0);
+
+        printf("Sleeping for 3 seconds...\n");
+        Thread::sleep(3*1000);
+
+        printf("Showing another message interrupting the previous one for 3 seconds\n");
+        xplane.showMessage("[basictest] but this message interrupts it, and is displayed for 3 seconds", 3.0);
+
+        printf("Sleeping for 5 seconds...\n");
+        Thread::sleep(5*1000);
+        xplane.showMessage("[basictest] and the tests come to an end!", 5.0);
 
         return 0;
Index: test/basictest.py
===================================================================
--- test/basictest.py	(revision 36)
+++ test/basictest.py	(revision 40)
@@ -1,3 +1,7 @@
 # Basic test program for the Python client library
+
+#------------------------------------------------------------------------------
+
+import time
 
 #------------------------------------------------------------------------------
@@ -12,4 +16,8 @@
         xplane.connect()
         print "Connected to X-Plane."
+        print
+
+        print "Showing a message..."
+        xplane.showMessage("[basictest] Starting tests", 5.0)
         print
 
@@ -133,4 +141,19 @@
         print
 
+        print "Preparing for the message tests, sleeping for 5 seconds..."
+        time.sleep(5.0)
+
+        print "Showing a message for 10 seconds..."
+        xplane.showMessage("[basictest] this message appears for 10 seconds", 10.0)
+
+        print "Sleeping for 3 seconds..."
+        time.sleep(3.0)
+
+        print "Showing another message interrupting the previous one for 3 seconds"
+        xplane.showMessage("[basictest] but this message interrupts it, and is displayed for 3 seconds", 3.0)
+
+        print "Sleeping for 5 seconds..."
+        time.sleep(5.0)
+        xplane.showMessage("[basictest] and the tests come to an end!", 5.0)
 
     except Exception as e: